/* Editor Settings: expandtabs and use 4 spaces for indentation
 * ex: set softtabstop=4 tabstop=8 expandtab shiftwidth=4: *
 * -*- mode: c, c-basic-offset: 4 -*- */

/*
 * Copyright Likewise Software    2004-2008
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.  You should have received a copy of the GNU General
 * Public License along with this program.  If not, see 
 * <http://www.gnu.org/licenses/>.
 *
 * LIKEWISE SOFTWARE MAKES THIS SOFTWARE AVAILABLE UNDER OTHER LICENSING
 * TERMS AS WELL.  IF YOU HAVE ENTERED INTO A SEPARATE LICENSE AGREEMENT
 * WITH LIKEWISE SOFTWARE, THEN YOU MAY ELECT TO USE THE SOFTWARE UNDER THE
 * TERMS OF THAT SOFTWARE LICENSE AGREEMENT INSTEAD OF THE TERMS OF THE GNU
 * GENERAL PUBLIC LICENSE, NOTWITHSTANDING THE ABOVE NOTICE.  IF YOU
 * HAVE QUESTIONS, OR WISH TO REQUEST A COPY OF THE ALTERNATE LICENSING
 * TERMS OFFERED BY LIKEWISE SOFTWARE, PLEASE CONTACT LIKEWISE SOFTWARE AT
 * license@likewisesoftware.com
 */

/*
 * Copyright (C) Centeris Corporation 2004-2007
 * Copyright (C) Likewise Software 2007
 * All rights reserved.
 *
 * Authors: Krishna Ganugapati (krishnag@likewisesoftware.com)
 *          Sriram Nambakam (snambakam@likewisesoftware.com)
 *
 * Eventlog parser to help parse log file output from Microsoft Event Viewer.
 *
 */
#ifndef __EVTPARSER_H__
#define __EVTPARSER_H__

typedef DWORD (*PFNEventRecordProcessor)(
                    PEVENT_LOG_HANDLE pEventLogHandle,
                    EVENT_LOG_RECORD  eventRecord
                    );

DWORD
ParseEvents(
    PSTR pszFilePath,
    PFNEventRecordProcessor eventRecordProcessor
    );

DWORD
ParseAndAddEvents(
    PEVENT_LOG_HANDLE pEventLogHandle,
    PSTR   pszFilePath,
    PSTR   pszEventTableCategoryId,
    BOOLEAN bEventTableCategoryIdInCSV,
    PFNEventRecordProcessor eventRecordProcessor
    );

DWORD
PrintEventRecords(
    FILE* output, 
    EVENT_LOG_RECORD* eventRecords, 
    DWORD nRecords,
    PDWORD totalRecords
    );

DWORD
PrintEventRecordsTable(
    FILE* output, 
    EVENT_LOG_RECORD* eventRecords, 
    DWORD nRecords,
    PDWORD totalRecords
    );

DWORD
ReadAndExportEvents(
    PEVENT_LOG_HANDLE pEventLogHandle,
    FILE* fpExport
    );

#endif
